# coding=utf-8
__author__ = 'Aranna'

def breakDir(fileName):
	return [x for x in fileName.split(u'/') if not x in (u'', None, '')]

def checaEstrutura(REPO, fileName):
	"""
	:type repo: cmislib.model.CmisClient
	:type fileName: str or unicode
	:param repo:	REPOSITORIO
	:param fileName:	DIRETORIO + NOME_ARQUIVO
	:return: True or False
	"""
	try:
		# se nao encontrar, vai gerar RAISE
		REPO.getObjectByPath(fileName)
		return True
	except:
		return False

def criaEstrutura(REPO, fileName, criarDocumento=True):
	dirs = breakDir(fileName)[:-1]
	parent = REPO.getRootFolder()
	diretorio = None

	for i in range(len(dirs)):
		# tenta pegar, se nao, cria
		try:
			diretorio = REPO.getObjectByPath(
				u'/' +
				u'/'.join( dirs[:i+1]) +
				u'/'
			)
		except:
			diretorio = parent.createFolder( dirs[i] )

		parent = diretorio
	if criarDocumento:
		return diretorio.createDocumentFromString(
			breakDir(fileName)[-1:][0],
			contentString=u'\n',
			contentType='text/plain',
			contentEncoding =u'utf-8'
		)

	return diretorio

def checaScript(REPO, fileName):
	try:
		REPO.getObjectByPath(
			u'/Data Dictionary/Scripts/' + fileName
		)
		return True
	except:
		return False

def criarScript(REPO, fileName):
	#	busca o diretorio
	import os
	from configuracoes import CMIS_ARQUIVO, CMIS_ROOT

	diretorio = REPO.getObjectByPath(u'/Data Dictionary/Scripts/')
	scriptDir = u'%s/%s'%( os.path.dirname(__file__), u'SCRIPT-CONTADOR.js' )

	arq = open(scriptDir, u'rb')
	script = arq.read()
	arq.close()

	script = unicode(script).replace(u'{CMIS_ARQUIVO}',CMIS_ARQUIVO).replace(u'{CMIS_ROOT}', CMIS_ROOT)

	return diretorio.createDocumentFromString(
		fileName,
		contentString=script,
		contentType='text/plain',
		contentEncoding=u'utf-8'
	)
